
Test = 1; % welche Anfangs- und Randwerte gewählt werden
Verfahren = 1; % welches Verfahren gewählt wird

f = @(x) Inhalt(x); %Inhaltsfunktion
gradf = @(x) Gradient_Inhalt(x); %Gradient

switch Test
    
    case 1  % erster Anfangswert - 0 am Rand, 1 im Inneren
        
        n = 5; % Anzahl Knoten pro Richtung
        U0 = ones(n^2,1);
        for i = 1:n-2
            for j = 1:n-2
                U0(i*n+j+1) = 0;
            end
        end
        tol = 1e-06; % Toleranz für beide Verfahren
        
    case 2 % zweiter Anfangs/Randwert: die Funktion sin(xy\pi)
        
        n = 20; % Anzahl Knoten pro Richtung
        h = 1/(n -1); % Schrittweite
        % Gitterpunkte erstellen
        x = 0:h:1;
        y = 0:h:1;
        [X,Y] = meshgrid(x,y);
        % Funktion auswerten
        Z = sin(Y.*X.*pi);
        U0 = Z(:);
        tol = 1e-03; % Toleranz für beide Verfahren - hier geringer!
        
end
    
switch Verfahren
    
    case 1 % erstes Verfahren (von Blatt 2)
        
    h = 1; %Anfangsschrittweite
    %Minimum berechnen
    [AU, h_it, U_it] = Verfahren1(U0, h, tol, f);
    disp(['Minimaler Flächeninhalt ist ' mat2str(AU(end))])
    % Visualisierung des Verfahrens
    for q = 1:size(U_it,2)
       plot_results(U_it(:,q));
       pause
       hold off
    end
    
    case 2 % Gradientenverfahren

    %Armijoparameter definieren
    beta = 0.5;
    gamma = 0.01;
    %Minimum berechnen
    [fz, z, grad] = Gradient_mit_Armijo(f, gradf, U0, beta, gamma, tol);
    disp(['Minimaler Flächeninhalt ist ' mat2str(fz(end))])
    % Visualisierung des Verfahrens
    for q = 1:size(z,2)
        plot_results(z(:,q));
        pause
        hold off
    end
    
end
